package org.jastadd.relast.tests;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.jastadd.relast.compiler.Compiler;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;

import static org.jastadd.relast.tests.TestHelpers.exec;
import static org.jastadd.relast.tests.TestHelpers.readFile;


class Errors {

  private static final Logger logger = LogManager.getLogger(Errors.class);
  @Test
  void test1() throws IOException {

    String inFile = "./src/test/jastadd/errors/Errors.relast";
    String outFile = "./src/test/jastadd/errors/Errors.out";
    String expectedFile = "./src/test/jastadd/errors/Errors.expected";

    try {
      System.out.println(System.getProperty("user.dir"));
      int returnValue = exec(Compiler.class, new String[]{inFile}, new File(outFile));
      Assertions.assertEquals(1, returnValue, "Relast did not return with value 1");
    } catch (IOException | InterruptedException e) {
      e.printStackTrace();
    }

    String out = readFile(outFile, Charset.defaultCharset());
    String expected = readFile(expectedFile, Charset.defaultCharset());

    Assertions.assertEquals(out, expected);

    logger.info("'relast Errors.relast' returned \n{}", out);
  }

  @Test
  void test2() throws IOException {

    String inFile = "./src/test/jastadd/errors/Inheritance.relast";
    String outFile = "./src/test/jastadd/errors/Inheritance.out";
    String expectedFile = "./src/test/jastadd/errors/Inheritance.expected";

    try {
      System.out.println(System.getProperty("user.dir"));
      int returnValue = exec(Compiler.class, new String[]{inFile}, new File(outFile));
      Assertions.assertEquals(1, returnValue, "Relast did not return with value 1");
    } catch (IOException | InterruptedException e) {
      e.printStackTrace();
    }

    String out = readFile(outFile, Charset.defaultCharset());
    String expected = readFile(expectedFile, Charset.defaultCharset());

    Assertions.assertEquals(out, expected);

    logger.info("'relast Inheritance.relast' returned \n{}", out);
  }


}
